function geomaps_escapeHtml(strText)
{
    if (strText == null)
    {
        strText = "";
    }
    var map =
    {
        '&': '&amp;',
        '<': '&lt;',
        '>': '&gt;',
        '"': '&quot;',
        "'": '&#039;'
    };
    return strText.replace(/[&<>"']/g, function(m) { return map[m]; });
}

function geomaps_decodeHtml(str)
{
    var map =
    {
        '&amp;': '&',
        '&lt;': '<',
        '&gt;': '>',
        '&quot;': '"',
        '&#039;': "'"
    };
    return str.replace(/&amp;|&lt;|&gt;|&quot;|&#039;/g, function(m) {return map[m];});
}

function set_list_states_for_status_changed(lstIssuesStatus)
{
    alert("set_list_states_for_status_changed !");
}

var fieldIdGeomaps;

// Namespace declaration
$(document).ready(function()
{
    var original_buildFilterRow = buildFilterRow;

    buildFilterRow = function(field, operator, values)
    {
        original_buildFilterRow.apply(this, arguments);
        var filterOptions = availableFilters[field];

        if (filterOptions['type'] == 'state_change_to')
        {
            fieldIdGeomaps = field.replace('.', '_');
            var td_value = $('#tr_' + field).find('td.values');
            td_value.html('');

            // Date begin
            td_value.append('<span><input type="date" name="v[' + fieldIdGeomaps + '][]" id="values_' + fieldIdGeomaps + '_1" class="value date_value geomaps_date_value" size="10" title="' + I18n.javascript.state_change_to_date_begin + '" value="' + ((values != null && Array.isArray(values) && values.length >=1 && values[0] != null) ? geomaps_escapeHtml(values[0]) : "") + '"></input></span>');
            // Date fin
            td_value.append('<span><input type="date" name="v[' + fieldIdGeomaps + '][]" id="values_' + fieldIdGeomaps + '_2" class="value date_value geomaps_date_value" size="10" title="' + I18n.javascript.state_change_to_date_end   + '" value="' + ((values != null && Array.isArray(values) && values.length >=2 && values[1] != null) ? geomaps_escapeHtml(values[1]) : "") + '"></input></span>');
            // Statut
            td_value.append('<span style=""><select name="v['   + fieldIdGeomaps + '][]" id="values_' + fieldIdGeomaps + '_3" class="value geomaps_state_value" title="'                     + I18n.javascript.state_change_to_state      + '">' + geomaps_get_status_options((values != null && Array.isArray(values) && values.length >=3 && values[2] != null) ? geomaps_escapeHtml(values[2]) : "") + '"</select><span class="toggle-multiselect">&nbsp;</span>');
        }
    };
});