module Geomaps::Patches::Models
  module QueryPatch
    def self.included(base)
      base.send :include, InstanceMethods

      base.class_eval do
        # chain method sql_for_field
        alias_method_chain :sql_for_field, :state_change_to
        # Allow column
        #self.available_columns << QueryColumn.new(:state_change_to)
        self.available_columns << QueryColumn.new(:date_from) << QueryColumn.new(:date_to) << QueryColumn.new(:state_value)
      end
    end

    module InstanceMethods
      def sql_for_field_with_state_change_to(field, operator, value, db_table, db_field, is_custom_filter = false)
        #Rails.logger.info("===========================================================================================================")
        #Rails.logger.info("============================================= geomaps plugin =============================================")
        #Rails.logger.info("= sql_for_field_with_state_change_to = field = #{field} / type = #{type_for(field)}")
        #Rails.logger.info("-----------------------------------------------------------------------------------------------------------")
        return sql_for_field_without_state_change_to(field, operator, value, db_table, db_field, is_custom_filter) unless type_for(field) == :state_change_to
        
        sql = ""

        # Helper method to generate the WHERE sql for a +field+, +operator+ and a +value+
        bOk = false
        if operator == "><" && value != nil
          bOk, errorMessage, date_begin, date_end, state_value = isStateChangeToValid?(value)          
        end

        if bOk
          case operator
          when "><"
            #sql = select * from journals left join journal_details on journals.id=journal_details.journal_id where 
            sql = "issues.id IN " +
                  "(" +
                    "SELECT DISTINCT journals.journalized_id " + 
                    "FROM journals " +
                    "LEFT JOIN journal_details ON journals.id = journal_details.journal_id " +
                    "WHERE journals.journalized_type = 'Issue' " +
                         "and prop_key = 'status_id' " +
                         "and journal_details.value IN ('#{state_value}') " +
                         "and journals.created_on::date >= '#{date_begin.strftime('%F')}' " +
                         "and journals.created_on::date <= '#{date_end.strftime('%F')}'" +
                  ")"
          end
        else
          # !! WE NEVER COME HERE !!
          error = label_for(:state_change_to) + l(error, :scope => 'activerecord.errors.messages')
          Rails.logger.error("Error while reading parameters : #{error}")
          sql = "'1' = '0'" # prevent crashing
        end
        sql
      end
    end # Module InstanceMethods

  end # Module QueryPatch
end # Module Geometry